
// Section 2 Review, Question 1 Solution

// Write a private communication system where a user can privatly talk to another user.  When the user
// uses the verb, his or her name should be clickable as a link.  The link should let the receiving user use
// the same private communication verb with the player's name supplied.  The player should not be able to talk
// to his or herself. (Hint: you can use the \ref text macro to send the user's reference)


mob
	Topic(href, list/href_list)
		..()
		var/action = href_list["action"]
		if(action == "whisper")
			// dereference the receiver by using locate() on the reference text
			var/mob/receiver = locate(href_list["value"])
			if(receiver) // ensure that you do not do anything if a null reference was found
				// let the user manually input their text, and call whisper() as a proc
				var/msg = input(src, "Talk privatly to another user in the program", "Whisper") as null|text
				src.whisper(receiver, msg)

	verb
		whisper(mob/M as mob in world, msg as text)
			set desc = "Talk privatly to another user in the program"
			if(!msg) return;
			// send the appropiate reference and src parameter to who is meant to click the link
			src << "You tell <a href=byond://?src=\ref[src]&action=whisper&value=\ref[M]>[M.name]</a>: [msg]"
			M << "<a href=byond://?src=\ref[M]&action=whisper&value=\ref[src]>[src.name]</a> tells you: [msg]"


