
// Section 2 - "Communication", Example 4
// An example showing how you can create a simple class selection system using hyperlinks.

mob
  var/class

  Topic(href, list/href_list)
    var/action = href_list["action"]
    if(action == "classpick")
      var/newclass = href_list["value"]
      if(newclass)
        src << browse(null, "window=classpick") // close the window
        src.SelectClass(newclass)

  verb/choose_class()
    var/text = \
    {"
      What class would you like to pick? <br />
       - <a href=byond://?src=\ref[src]&action=classpick&value=Soldier>Soldier</a><br />
       - <a href=byond://?src=\ref[src]&action=classpick&value=Mage>Mage</a><br />
       - <a href=byond://?src=\ref[src]&action=classpick&value=Archer>Archer</a>
    "}

    src << browse(text, "window=classpick;size=500x300")

  proc/SelectClass(cls)
    src << "You are now a [cls]!"
    src.class = cls